import Migrate.*;
import java.io.*;

class Collector extends Thread {
	ReturnBuffer xrb;
	public Collector (ReturnBuffer rb) {
		super();
		xrb = rb;
	}
	public void run() {
		    while (true) System.out.println(xrb.get() );
	}
}

public class Client {
    public static void main(String args[]) {
        try {
	    // create an agent to be sent out       
	    BufferedReader stdin =
                new BufferedReader(new InputStreamReader(System.in));
    	    System.out.print("Number =");
	    String line = stdin.readLine();
	    int k = Integer.parseInt(line);

	    Migrateable agent1 = new Pi(k);

	    // create and fill the itinerary
	    ItineraryServant iten = new ItineraryServant();
	    iten.addHost("Agency1");

	    // create a buffer what the XServerNotify will write 
            ReturnBuffer rbuf = new ReturnBuffer();

	    Collector col = new Collector(rbuf);
	    col.start();
	    try {
		// create the orb client for starting the agent
		ClientOrb myclientorb = new ClientOrb(args);
		myclientorb.startAgent(agent1, iten, rbuf, "mypi.jar");
	    }
	    catch (Exception e) {
		col.stop();
		throw e;
	    }

	    // getting the result
            java.lang.Object sync = new java.lang.Object();
            synchronized (sync) {
                sync.wait();
	    }
 	    col.stop();

        } 
        catch (Exception e) {
            System.out.println("ERROR : " + e) ;
            e.printStackTrace(System.out);
        }
    }
}
