import Migrate.*;
import org.omg.CosNaming.*;
import org.omg.CORBA.*;
import java.io.*;


public class ClientOrb {

    private String[] args;
    private static final int BOUND = 100000;

    public ClientOrb(String[] params) {
	args = params;
    }


    public void startAgent(Migrateable agent1, ItineraryServant iten, ReturnBuffer rbuf, String jarname)
		 throws Exception {

            // create and initialize the ORB
            ORB orb = ORB.init(args, null);
 
            // get the root naming context
            org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
            NamingContext ncRef = NamingContextHelper.narrow(objRef);

	    // pass the agent to the first server
	    if (! iten.isEmpty()) {

   		// resolve the Object Reference in Naming
		String nexthoststring = iten.getNext();
            	NameComponent nc = new NameComponent(nexthoststring, "");
            	NameComponent path[] = {nc};
            	Agency nexthost = AgencyHelper.narrow(ncRef.resolve(path));

		// connect semafor to CORBA 
            	XNotifiedServant xnotifiedRef = new XNotifiedServant(rbuf);
            	orb.connect(xnotifiedRef);

            	// create the stringified code
		String fname = new String(jarname);
		InputStream inf = new FileInputStream(fname);
		byte[] tmpcode = new byte[BOUND];
		int codelength = inf.read(tmpcode);
		if (codelength == BOUND) throw new IndexOutOfBoundsException("too long jar file");
		inf.close();
		byte[] classcode = new byte[codelength];
		for (int j=0; j<codelength; j++) classcode[j] = tmpcode[j];

		// stringify the agent object
		ByteArrayOutputStream bstream = new ByteArrayOutputStream();
		ObjectOutputStream out = new ObjectOutputStream(bstream);
            		out.writeObject(agent1);
		out.flush();
            	bstream.close();
		byte[] stringified = bstream.toByteArray();

		// passing itinerary by holder object
		ItineraryHolder ith = new ItineraryHolder(iten);

            	// pass the agent
		nexthost.remExe(classcode, stringified, xnotifiedRef, ith); 
            }
	    else throw new IllegalArgumentException("Itinerary is empty");    }
}
