import Migrate.*;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import java.io.*;
import java.net.*;
import java.util.*;
import Agents.mem.*;

public class AgencyServant extends _AgencyImplBase {

  NamingContext ncRef;
  String servername;
  static int nbr = 0;

  public void contextSetting(NamingContext ncont) {
    ncRef = ncont;
  }

  public void nameSetting(String name) {
    servername = name;
  }

  public void remExe(byte[] cls, byte[] str, 
		     XNotified callobj, 
		     ItineraryHolder itihold) {

    String filename = null;	
    synchronized (this)
      {
	nbr++;
	filename = "/xxx" + nbr +".jar";
      }
    Migrateable m = null;
    File jarFile = null;
    boolean error = false;


    System.out.println(servername  + " started");

    try {

      // Generate a local agent from strings 

      ClassLoader loader = null;

      // create jar file from cls
      //	  jarFile = File.createTempFile("xxx" + nbr, "jar");
      //	  FileOutputStream os = new FileOutputStream(jarFile);
      //	  os.write(cls);
      //	  os.close();

      debug(filename);
      MemoryHandler.addJar(filename, cls);	

      // create private ClassLoader for loading the jar file
      URL urls[] = new URL[1];
      //	  urls[0] = jarFile.toURL();
      urls[0] = MemoryHandler.toURL(filename);
      loader = new URLClassLoader(urls);

      // deserialize Agent from str using the private ClassLoader
      ByteArrayInputStream bstream = new ByteArrayInputStream(str);
      MigrateInputStream p = new MigrateInputStream(bstream, loader);
      java.lang.Object cc = null;           
      cc = p.readObject();
      bstream.close();
      m = (Migrateable)cc;
      // m is the Agent
    }
    catch (Exception e)
      {
	System.out.println("Agent creation error\n" + e.toString());
	// notify the assigned object
	error = true;
	try {
	  callobj.clientNotify("Agent creation error", servername);
	  // itinerary
	  Migrate.Itinerary itin = itihold.value;

	  // take the next agency - if there is
	  if (! itin.isEmpty()) {

	    // resolve the Object Reference in Naming
	    String nexthoststring = itin.getNext();
	    NameComponent nc = new NameComponent(nexthoststring, "");
	    NameComponent path[] = {nc};
	    Agency nexthost = AgencyHelper.narrow(ncRef.resolve(path));

	    // start the next servant
	    nexthost.remExe(cls, str, callobj, itihold); 
	  }
	}
	catch (Exception ee)
	  {
	    System.out.println("Unexpected agent termination\n" + ee.toString());
	    callobj.clientNotify("Unexpected agent termination", servername);	
	  }

      }

    // Use the agent 
    if (!error) {
      try {
	// execute Agent program

	String resultstring = m.execute(servername);

	// notify the assigned object
	callobj.clientNotify(resultstring, servername);



      }
      catch (Exception eee)
	{	
	  // notify the assigned object
	  System.out.println("Agent exception\n" + eee.toString());
	  callobj.clientNotify("Agent exception", servername);
	}

      // Redirect Agent to the next server

      try {
	// delete jar file
	//	  jarFile.delete();
	MemoryHandler.delJar(filename);


	// itinerary
	Migrate.Itinerary itin = itihold.value;

	// take the next agency - if there is
	if (! itin.isEmpty()) {

	  // resolve the Object Reference in Naming
	  String nexthoststring = itin.getNext();
	  NameComponent nc = new NameComponent(nexthoststring, "");
	  NameComponent path[] = {nc};
	  Agency nexthost = AgencyHelper.narrow(ncRef.resolve(path));

	  // serialize the the actual version of the Agent
	  ByteArrayOutputStream xstream = new ByteArrayOutputStream();
	  ObjectOutputStream out = new ObjectOutputStream(xstream);
	  out.writeObject(m);
	  out.flush();
	  xstream.close();
	  byte[] stringified = xstream.toByteArray();

	  // start the next servant

	  nexthost.remExe(cls, stringified, callobj, itihold); 
	}
      }
      catch (Exception eeee)
	{
	  System.out.println("Unexpected agent termination \n" + eeee.toString());
	  callobj.clientNotify("Unexpected agent termination", servername);		
	}
    }
  }
  void debug(String s)
    { 
////      		System.err.println(s); 
    }
}


