import Migrate.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;
import Agents.mem.*;

public class AgencyServer {


  public static void main(String args[]) {
    
   String servantname = " ";

    // parsing arguments
    for (int i = 0; i < args.length; i++)
      {
	if (args[i].equals("-name"))
	  {
	    i++;
	    servantname = args[i];
	  }
	else if (args[i].equals("-help") || args[i].equals("-h") )
	  {
	    System.out.println("Usage: java AgencyServer -name <name> [<CORBA options>]");
	    System.out.println("where:");
	    System.out.println("	name is the name of the server in the name service");
	    System.exit(0);
	  }
      }

    try {

      // create and initialize the ORB	
      ORB orb = ORB.init(args, null);

      // create servant and register it with the ORB
      AgencyServant AgencyRef = new AgencyServant();
      orb.connect(AgencyRef);

      // pass the name to the servant
      AgencyRef.nameSetting(servantname);

      // get the root naming context
      org.omg.CORBA.Object objRef = 
	orb.resolve_initial_references("NameService");
      NamingContext ncRef = NamingContextHelper.narrow(objRef);

      // pass the naming context to the servant
      AgencyRef.contextSetting(ncRef);

      // bind the Object Reference in Naming
      NameComponent nc = new NameComponent(servantname, "");
      NameComponent path[] = {nc};
      ncRef.rebind(path, AgencyRef);

      // sign on message to the console
      System.out.println(servantname + " AgencyServant ready");

      // wait for invocations from clients
      java.lang.Object sync = new java.lang.Object();
      synchronized (sync) {
	sync.wait();
      }
    } 
    catch (Exception e) {
      System.err.println("ERROR: " + e);
      e.printStackTrace(System.out);
    }
  }
}


