package Agents.mem;

import java.io.*;
import java.util.*;

import java.net.*;

public class MemoryHandler
{
  static Hashtable input = null;
  static Hashtable output = null;
  static boolean HandlerInitialized = false;

  static public void initialize()
    {}

  static
    {
      if (input == null)
	input = new Hashtable();
      if (output == null)
	output = new Hashtable();

      if (!HandlerInitialized)
	{
	  
	  String prop = System.getProperty("java.protocol.handler.pkgs");
	  if (prop == null)
	    prop = "";
	  else if (prop.equals("null"))
	    prop = "";
	  else
	    prop = prop +"|";
	  
	  String pack = "Agents";
	  prop = prop + pack;
	  System.setProperty("java.protocol.handler.pkgs", prop);
	  
	  HandlerInitialized = true;
	}


    }

  static public ByteArrayInputStream getInput(String name)
    {
      ByteArrayInputStream bi = 
	(ByteArrayInputStream)(((Block)input.get(name)).getObject());
      bi.reset();
      return bi;
    }
  static public ByteArrayOutputStream getOutput(String name)
    {
      ByteArrayOutputStream bo = 
	(ByteArrayOutputStream)(((Block)output.get(name)).getObject());
      bo.reset();
      return bo;
    }

  static public void putInput(String name, ByteArrayInputStream in)
    {
      debug("Putting in input...");
      Block bl = null;
      if (input.containsKey(name))
	{
	  bl = (Block)input.get(name);
	}
      else
	{
	  bl = new Block();
	  input.put(name, bl);
	}
      bl.increment();
      bl.setObject(in);
      debug("Input "+name+" put in.");
    }

  static public void deleteInput(String name)
    {
      if (input.containsKey(name))
        {
          Block bl = (Block)input.get(name);
	  bl.decrement();
	  if (bl.getCounter() < 1)
	    input.remove(name);
        }
    }

  static public void putOutput(String name, ByteArrayOutputStream in)
    {
      Block bl = null;
      if (output.containsKey(name))
	{
	  bl = (Block)output.get(name);
	}
      else
	{
	  bl = new Block();
	  output.put(name, bl);
	}
      bl.increment();
      bl.setObject(in);
    }

  static public void deleteOutput(String name)
    {
      if (output.containsKey(name))
        {
          Block bl = (Block)output.get(name);
	  bl.decrement();
	  if (bl.getCounter() < 1)
	    output.remove(name);
        }
    }

  static public void addJar(String name, byte[] b)
    {
      debug("Betett: "+name+", "+b.length+" byte");
      ByteArrayInputStream is = new ByteArrayInputStream(b);
      putInput(name, is);
    }
  static public void delJar(String name)
    {
      deleteInput(name);
    }

  static public URL toURL(String name)
    {
      URL url = null;
      try
	{
	  url = new URL("mem", "localhost", 1, name);
	}
      catch (Exception e)
	{
	}

      return url;
    }


  static void debug(String s)
    {
//      System.err.println(s);
    }


}
